pragma synchronous = off;

CREATE TABLE corpus(
id INTEGER PRIMARY KEY AUTOINCREMENT,
collection VARCHAR(16) NOT NULL,
language VARCHAR(2) NOT NULL,
title VARCHAR(64) NOT NULL,
source VARCHAR(4) NOT NULL,
UNIQUE(collection, language, title, source)
);

CREATE TABLE term(
id INTEGER PRIMARY KEY AUTOINCREMENT,
language VARCHAR(2) NOT NULL,
lemma VARCHAR(32) NOT NULL,
pos VARCHAR(12) DEFAULT NULL,
UNIQUE(language, lemma, pos)
);

CREATE TABLE corpus_term(
corpus_id INT UNSIGNED NOT NULL,
term_id INT UNSIGNED NOT NULL,
count INTEGER UNSIGNED NOT NULL,
UNIQUE(corpus_id, term_id)
);

CREATE TABLE translation(
source VARCHAR(2) NOT NULL,
target VARCHAR(2) NOT NULL,
word VARCHAR(32) NOT NULL,
pos VARCHAR(12) DEFAULT NULL,
equal VARCHAR(32) NOT NULL,
UNIQUE(source, target, word, pos, equal)
);