package impl.evaluation.splitting;

import impl.indexing.CorpusIndexer;
import impl.indexing.parsing.OpusCorpusParser;
import impl.model.CorpusService;
import impl.model.Database;
import impl.model.Environment;

import java.io.File;

public class CwsRIndexer {
	private static CorpusIndexer corpusIndexer;

	public static void main(String[] args) throws InterruptedException {
		Database database = new Database(Environment.getInstance().getProperty("test-db-cws-r"));
		corpusIndexer = new CorpusIndexer(new CorpusService(database));
		corpusIndexer.register(
				"Opus",
				new File(Environment.getInstance().getProperty("opusParallelCorporaDirectory")),
				new OpusCorpusParser(null, true)
		);
		Runtime.getRuntime().addShutdownHook(new Thread(new Runnable() {
			public void run() {
				System.out.println("Preparing to terminate...");
				corpusIndexer.terminate();
				System.out.println("Terminating");
			}
		}));
		corpusIndexer.start();
	}
}
