package impl.evaluation.splitting;

import impl.indexing.CorpusIndexer;
import impl.indexing.parsing.AvisCorusParser;
import impl.indexing.parsing.OpusCorpusParser;
import impl.indexing.parsing.TenTenCorusParser;
import impl.language.Language;
import impl.model.CorpusService;
import impl.model.Database;
import impl.model.Environment;

import java.io.File;

public class ExternalIndexer {
	private static CorpusIndexer corpusIndexer;

	public static void main(String[] args) throws InterruptedException {
		Database database = new Database(Environment.getInstance().getProperty("test-db-ext"));
		corpusIndexer = new CorpusIndexer(new CorpusService(database));
		corpusIndexer.register(
				"Opus",
				new File(Environment.getInstance().getProperty("opusExternalCorporaDirectory")),
				new OpusCorpusParser(7000)
		);
		//corpusIndexer.register(
		//		"Avis",
		//		new File(Environment.getInstance().getProperty("avisKorpusDirectory")),
		//		new AvisCorusParser()
		//);
		//corpusIndexer.register(
		//		"noTT",
		//		new File(Environment.getInstance().getProperty("noTenTenDirectory")),
		//		new TenTenCorusParser(Language.NO)
		//);
		Runtime.getRuntime().addShutdownHook(new Thread(new Runnable() {
			public void run() {
				System.out.println("Preparing to terminate...");
				corpusIndexer.terminate();
				System.out.println("Terminating");
			}
		}));
		corpusIndexer.start();
	}
}
