package impl.indexing.parsing;

import impl.language.Language;
import impl.model.CorpusService;

import java.io.InputStream;

public interface CorpusParser {
	void setSource(Object source) throws IllegalArgumentException;
	void setCorpusService(CorpusService cs);
	void indexFromSource() throws IllegalStateException;
	RawCorpusAccess getRawCorpusAccess(String collection, Language language, String title) throws Exception;
	void terminate();
	class RawCorpusAccess {
		public InputStream stream;
		public long length;
		public String mime;

		public RawCorpusAccess(InputStream stream, long length) {
			this.stream = stream;
			this.length = length;
		}

		public RawCorpusAccess(InputStream stream, long length, String mime) {
			this.stream = stream;
			this.length = length;
			this.mime = mime;
		}
	}
}
