package impl.model;

import java.io.*;
import java.sql.*;

public class Database {
	private String path;
	//private SQLiteConfig config;
	private Connection connection;
	private boolean isNew;

	public Database() {
		path = ":memory:";
		//config = new SQLiteConfig();
		connection = null;
		isNew = true;
	}

	public Database(String path) {
		this.path = path;
		//config = new SQLiteConfig();
		connection = null;
		isNew = true;//!(new File(path).isFile());
	}

	public boolean isNew() {
		return isNew;
	}

	public Connection getConnection() {
		if (connection == null) {
			File sqlFile = new File("db/setup.sql");
			try {
				//connection = config.createConnection("jdbc:sqlite:" + path);
				//connection = DriverManager.getConnection("jdbc:sqlite:" + path, config.toProperties());
				//connection = DriverManager.getConnection("jdbc:sqlite:" + path);
				Class.forName("com.mysql.jdbc.Driver");
				connection = DriverManager.getConnection(
						"jdbc:mysql://" +
								Environment.getInstance().getProperty("mysql.addr") +
								":" +
								Environment.getInstance().getProperty("mysql.port") +
								"/" + path,
						Environment.getInstance().getProperty("mysql.user"),
						Environment.getInstance().getProperty("mysql.pass")
				);
				if (!isNew) {
					//connection.setReadOnly(true);
					return connection;
				}
				FileReader fr = new FileReader(sqlFile);
				BufferedReader br = new BufferedReader(fr);
				StringBuffer sb = new StringBuffer();
				String str;
				while ((str = br.readLine()) != null) {
					sb.append(str + "\n");
				}
				br.close();
				fr.close();
				Statement stmt;
				for (String command : sb.toString().split("[;]+")) {
					if (!"".equals(command.trim())) {
						stmt = connection.createStatement();
						stmt.execute(command);
						stmt.close();
					}
				}
			} catch (SQLException e) {
				e.printStackTrace();
			} catch (FileNotFoundException e) {
				System.err.println(sqlFile.getAbsolutePath());
			} catch (IOException e) {
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}
		}
		return connection;
	}

	//public void readOnly() {
		//config.setReadOnly(true);
	//}
}
