package impl.model;

import java.io.*;
import java.util.Properties;

public class Environment {
	private Properties properties = null;

	private static Environment instance = null;

	public static Environment getInstance() {
		if (instance == null) {
			instance = new Environment();
		}
		return instance;
	}

	private Environment() {
		try {
			String path = "environment.properties";
			InputStream is = new FileInputStream(path);
			if (is == null) {
				System.err.println("File not found: " + path);
				return;
			}
			properties = new Properties();
			properties.load(is);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String getProperty(String name) {
		if (properties == null) {
			return null;
		}
		return properties.getProperty(name);
	}
}
