package impl.model;

public class Term {
	public String lemma;
	public String pos;
	public boolean isName;

	public Term(String lemma, String pos) {
		this.lemma = lemma;
		this.pos = pos;
	}

	public String toString() {
		return lemma + "(" + pos + ")";
	}

	public String toJson() {
		return "{\"lemma\":\"" + lemma + "\",\"pos\":\"" + pos + "\"}";
	}

	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof Term)) {
			return false;
		}
		if (obj == this) {
			return true;
		}
		Term other = ((Term) obj);
		if (pos == null || other.pos == null) {
			return pos == other.pos && lemma.equals(other.lemma);
		}
		return pos.equals(other.pos) && lemma.equals(other.lemma);
	}

	@Override
	public int hashCode() {
		return ((lemma == null ? 0 : lemma.hashCode()) % 53 + 3) * ((pos == null ? 0 : pos.hashCode()) % 82 + 43);
	}
}
