package impl.model;

import java.util.List;

public class Useful {
	public static String join(String[] parts, String separator) {
		if (parts.length == 0) {
			return "";
		}
		String combined = parts[0];
		for (int i = 1; i < parts.length; i++) {
			combined += separator + parts[i];
		}
		return combined;
	}

	public static String join(List<String> parts, String separator) {
		if (parts.size() == 0) {
			return "";
		}
		String combined = parts.get(0);
		for (int i = 1; i < parts.size(); i++) {
			combined += separator + parts.get(i);
		}
		return combined;
	}

	public static String stripTags(String input) {
		int level_tag = 0;
		String output = "";
		for (int i = 0; i < input.length(); i++) {
			switch (input.charAt(i)) {
				case '<':
					level_tag++;
					break;
				case '>':
					level_tag--;
					break;
				default:
					if (level_tag == 0) {
						output += input.charAt(i);
					}
			}
		}
		return output;
	}

	public static String stripElements(String input) {
		int level_tag = 0;
		int level_inner = 0;
		String output = "";
		for (int i = 0; i < input.length(); i++) {
			switch (input.charAt(i)) {
				case '<':
					level_tag++;
					level_inner += input.charAt(++i) == '/' ? -1 : 1;
					break;
				case '>':
					level_tag--;
					break;
				default:
					if (level_tag == 0 && level_inner == 0) {
						output += input.charAt(i);
					}
			}
		}
		return output;
	}
}
