package impl.tool;

import impl.language.Language;
import impl.language.splitting.StatisticalSplitter;
import impl.model.Database;
import impl.model.Environment;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.*;

public class Blarg1 {
	public static void main(String[] args) {
		Database database = new Database(Environment.getInstance().getProperty("database"));
		Database external = new Database(Environment.getInstance().getProperty("test-db-ext"));
		StatisticalSplitter splitter = new StatisticalSplitter(Language.NO, external, false);
		iterate(database, splitter);
	}

	private static void iterate(Database database, StatisticalSplitter splitter) {
		String sql = "SELECT lemma FROM term WHERE language=? GROUP BY lemma ORDER BY RAND() LIMIT 100000;";
		try {
			PreparedStatement ps = database.getConnection().prepareStatement(sql);
			ps.setString(1, Language.NO.toString());
			ResultSet rs = ps.executeQuery();
			int i = 0;
			Set<String> words = new HashSet<String>();
			loop:
			for (;;) {
				for (;;) {
					if (!rs.next()) {
						break loop;
					}
					words.add(rs.getString(1));
					if (++i % 2000 == 0) {
						show(words, splitter);
						System.out.println(i);
						words = new HashSet<String>();
						continue loop;
					}
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	private static void show(Set<String> words, StatisticalSplitter splitter) {
		for (Map.Entry<String, String[]> entry : splitter.getReplacements(words, false).entrySet()) {
			System.out.println(entry.getKey() + ": " + Arrays.toString(entry.getValue()));
		}
	}
}
