package impl.tool;

import impl.evaluation.SearchService;
import impl.indexing.parsing.CorpusParser;
import impl.indexing.parsing.OpusCorpusParser;
import impl.language.Language;
import impl.language.Stopword;
import impl.model.*;

import java.io.*;
import java.util.Arrays;
import java.util.List;

public class Blarg2 {
	public static void main(String[] args) {
		Database database = new Database(Environment.getInstance().getProperty("database"));
		/*
		Scanner scanner = new Scanner(System.in);
		Language language = null;
		do {
			System.out.println("Language: [NO,EN,DE,ES]");
			try {
				language = Language.valueOf(scanner.next());
			} catch (Exception e) {
				e.printStackTrace();
			}
		} while(language == null);
		System.out.println("Phrase:");
		String phrase = scanner.next();
		evaluate(database, language, phrase);
		*/
		//evaluate(database, Language.NO, "sikkerhetskamera");
		//evaluate(database, Language.EN, "security camera"); // 2777
		//evaluate(database, Language.NO, "verdensreligion");
		//evaluate(database, Language.EN, "world religion"); // 4879
		//evaluate(database, Language.NO, "fengselsprest");
		//evaluate(database, Language.EN, "prison chaplain"); // 1000+
		//evaluate(database, Language.EN, "poirot"); // 6
		//evaluate(database, Language.NO, "stormannsgal"); // 3		good
		//evaluate(database, Language.EN, "megalomaniac"); // 0
		//evaluate(database, Language.ES, "megalómano"); // 3			good
		//evaluate(database, Language.NO, "radarbilde"); // 1
		//evaluate(database, Language.ES, "imagen de radar");
		//evaluate(database, Language.NO, "fjellgrunn");
		//evaluate(database, Language.NO, "grunnfjell"); // 0
		//evaluate(database, Language.DE, "gesteinen"); // 0
		//evaluate(database, Language.NO, "berggrunn"); // 0
		//evaluate(database, Language.EN, "bedrock"); // something
		//evaluate(database, Language.NO, "tvilstilfelle"); // 1
		//evaluate(database, Language.EN, "case of doubt");
		//evaluate(database, Language.NO, "adgangstillatelse");
		//evaluate(database, Language.EN, "access permit");
		//evaluate(database, Language.ES, "permiso de acceso");
		//evaluate(database, Language.NO, "kattunge"); // 9				good
		//evaluate(database, Language.EN, "kitten"); // 195
		//evaluate(database, Language.ES, "gatito"); // 0
		//evaluate(database, Language.DE, "kätzchen"); // 30			good
		//evaluate(database, Language.NO, "lånehai"); // 2
		//evaluate(database, Language.EN, "loan shark"); // 748
		//evaluate(database, Language.NO, "læretid"); // 0
		//evaluate(database, Language.EN, "apprenticeship");
		//evaluate(database, Language.ES, "aprendizaje");
		//evaluate(database, Language.NO, "skiftenøkkel"); // 5
		//evaluate(database, Language.NO, "skrunøkkel"); // 4
		//evaluate(database, Language.EN, "spanner"); // 3
		//evaluate(database, Language.ES, "llave inglesa");
		//evaluate(database, Language.NO, "folkefiende");
		//evaluate(database, Language.ES, "enemigo del pueblo"); // 1959
		//evaluate(database, Language.NO, "samfunnsdebatt"); // 0
		//evaluate(database, Language.ES, "debate social"); // 500
		//evaluate(database, Language.NO, "kapp verde");
	}

	private static void evaluate(Database database, Language language, String phrase) {
		System.out.println(phrase);
		Query query = getQuery(phrase, language);
		System.out.println(query.toString());
		SearchService ss = new SearchService(database);
		SearchReport srpt = ss.perform(query, language, false, null);
		List<SearchResult> corpora = srpt.getCorpora();
		System.out.println(corpora.size());
		CorpusParser cp = new OpusCorpusParser();
		cp.setSource(new File(Environment.getInstance().getProperty("opusParallelCorporaDirectory")));
		Corpus corpus;
		if (phrase.split("\\s+").length < 2) {
			for (SearchResult srlt : corpora) {
				System.out.println(srlt.getCorpus().getTitle());
			}
			return;
		}
		for (SearchResult srlt : corpora) {
			corpus = srlt.getCorpus();
			try {
				CorpusParser.RawCorpusAccess rca = cp.getRawCorpusAccess(corpus.getCollection(), language, corpus.getTitle());
				if (Useful.stripTags(streamtostring(rca.stream)).replaceAll("\\s+", " ").toLowerCase().contains(phrase)) {
					System.out.println(corpus.getTitle());
				}
				else {
					System.out.print("NOT " + corpus.getTitle() + "\r");
				}
			} catch (Exception e) {
			}
		}
		System.out.println();
	}

	private static Query getQuery(String phrase, Language language) {
		Query query = new Query(language);
		Stopword stopper = new Stopword(language);
		for (String part : stopper.process(Arrays.asList(phrase.split("\\s+")))) {
			query.addTerm(new Term(part, null));
		}
		return query;
	}

	private static String streamtostring(InputStream is) {
		try {
			InputStreamReader isr = new InputStreamReader(is);
			BufferedReader br = new BufferedReader(isr);
			StringBuilder sb = new StringBuilder();
			String line;
			while ((line = br.readLine()) != null) {
				sb.append(line + "\n");
			}
			br.close();
			isr.close();
			is.close();
			return sb.toString();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return "";
	}
}
